		; PROGRAMMA MEMORIA ITIS Q. Sella - BIELLA
		;
		;  	Data:            8-05-2009 - 26-05-2009

		;	Usa porta C per display  LCD
		;	Usa porta A per la memoria flash
		;	E. Bellincioni   U. Negro
	
		; *********************************************************************
		 .include "m32def.inc"
		 .cseg
         ;*********************************************************************
		 .DEF	DELAY0	= R10	;Delay regs in LCD routines. 
		 .DEF	DELAY1	= R11	;	''
	     .DEF	DELAY2	= R12	;	''
	     .DEF	DATLSB  = R13
	     .DEF	DATMSB	= R14
		 .DEF	DATBYT	= R15
	     .DEF	TEMP	= R16	;temporary working register
	     .DEF	XFR		= R17	;transfer register
	     .DEF	CONT	= R18	;Counter 
	     .DEF	TEMP0	= R19	;Reused as input values for BCD conversion (LSB)
	     .DEF	TEMP1	= R20	;	''
	     .DEF	TEMP2	= R21	;	'' (MSB)
		 .DEF  RECEIVE  = R22 
		 .DEF  U_CONT   = R23	;Contatore caratteri ASCII ricevuti dalla UART
		 .DEF   DATO    = R24
		 .DEF   CONTB   = R25
		 .DEF  U_NUMDATL= R28   ;Registro numero dati ricevuti (al massimo 65535 dati)
		 .DEF  U_NUMDATH= R29

          ;	LCD Display Parameters
          ;	======================

		  ; LCD commands defined

		  .EQU	cursor_home	    = 0b00000010	;bit order is DB7 DB6 DB5 DB4 RS 
		  .EQU	system_set	    = 0b00110000
		  .EQU	function_set    = 0b00101000
		  .EQU	display_off	    = 0b00001000
		  .EQU	display_clear   = 0b00000001
		  .EQU	entry_mode_set  = 0b00000110
		  ;.EQU	display_on	    = 0b00001100     

		  ; LCD ports defined

		  .EQU	RS1		 = 4    ;bit 2 PORTC     
	 	  .EQU	OE		 = 8	;bit 3 PORTC

		  .equ  LCD_PORT = PORTC
		  .equ  RS       = 2
		  .equ  E        = 3
	

		.org 0x0000
		jmp main
		.org 0x001A
		jmp UART_RXC	
		;
		;
main:	ldi r20,high(RAMEND)
        out SPH,r20
		ldi r20,low(RAMEND)
		out SPL,r20
		;

	    IN    R16,MCUCSR         ; disable JTAG
		ORI   R16,0x80
		OUT   MCUCSR,R16         ; write twice ,disable JTAG 
		OUT   MCUCSR,R16  
		
		call  del15m
		call  del15m       
		call  del15m
        ser   r20				 ; Porte C in uscita
		out   DDRC,r20

		;******************************************************************************
		ldi   R16,0b11111101	 ; Bit 1 della porta A in ingresso il resto della porta 
		out   DDRA,R16			 ; A  in uscita
		ldi   R16,0x0F
		out   PORTA,R16
		ser   R16
		out   DDRB,R16
		ldi   R16,0x08
		out   PORTA,R16
		LDI   R16,0xFE
		OUT   DDRD,R16  		; porta D  uscita
		call  del15m
		call  del15m
		;*****************************************************************************
				
        ;*****************************************************************************
		;*                               MAIN                                        *
		;*****************************************************************************

        call init_lcd             ; Inizializza LCD 
		call  del15m
		call  del15m
		call init_uart			  ; Inizializza la porta UART in full-duplex ISR in RX
		ldi  XH,high(0x0060)	  ; Inizializza puntatore SRAM alla prima cella della
		ldi  XL,low(0x0060)       ; memoria 		
		clr  U_CONT 			  ; Inizializza contatore caratteri ricevuti dalla UART
		clt  					  ; Azzera il Flag T Scrittura in MEMORIA
		;*******************************************************************************
			        			  ; Send the LCD sign-on message
		ldi		ZH, HIGH(2*TXT1)
		ldi		ZL, LOW(2*TXT1)
		rcall	LCDBLURB
		ldi 	XFR,0x40
		rcall   CURSOR
		ldi		ZH, HIGH(2*TXT2)
		ldi		ZL, LOW(2*TXT2)
		rcall	LCDBLURB				
		ldi 	XFR,0x00
		rcall   CURSOR
		ldi		ZH, HIGH(2*TXT3)
		ldi		ZL, LOW(2*TXT3)
		rcall	LCDBLURB		
		ldi 	XFR,0x40
		rcall   CURSOR
		ldi		ZH, HIGH(2*TXT4)
		ldi		ZL, LOW(2*TXT4)
		rcall	LCDBLURB
		
		sei						; Abilita l'interrupt generico
loop:	nop
		jmp 	loop
		
		;*********************************************************************
		;**********************  ISR - UART - Rx  ****************************
		;********************************************************************* 
UART_RXC:   
		
		
		brts    U_DATAWRITE ;Salta se il Flag T Scrittura in MEMORIA  settato
		cpi     U_CONT,11	;ATTENZIONE IL TEST DEVE ESSERE FATTO PER CONT !!!
		breq    U_DECODE
		in   	RECEIVE,UDR
		st      X+,RECEIVE
		inc     U_CONT
		clt
		reti

U_DECODE:
		ldi     XH,high(0x0060)	  
		ldi     XL,low(0x0060)       
		ld      TEMP0,X
		cpi     TEMP0,'W'
		breq    U_DEC_WRITE
		cpi     TEMP0,'R'
		breq    U_DEC_RESET
		cpi     TEMP0,'T'
        breq    U_MEM_STATUS
		cpi     TEMP0,'P'
        breq    U_MEM_PROG256
		cpi     TEMP0,'L'
        breq    U_DEC_LEGGI
		cpi     TEMP0,'A'
		breq    U_PROVAAUDIO
		cpi     TEMP0,'Z'
		breq    U_DEC_SILENZIO
		clr     U_CONT
		clt     
		reti

U_DATAWRITE:
		jmp     U_DATA_WRITE
U_DEC_WRITE:
		jmp     U_WRITE
U_DEC_RESET:
		jmp     U_RESET
U_MEM_STATUS:
		jmp     U_MEM
U_MEM_PROG256:
		jmp     U_PROG

U_DEC_LEGGI:
		jmp     U_LEGGI

U_PROVAAUDIO:
		jmp     U_AUDIO

U_DEC_SILENZIO:
		jmp     U_SILENZIO


		;*********************************************************************
		;************************ UART initialization ************************
		;*********************************************************************
		
INIT_UART:	
		ldi  temp0,high(103)
		ldi  temp1,low(103)
		out  UBRRH,temp0
		out  UBRRL,temp1
		ldi  temp1,(1<<RXCIE)|(1<<RXEN)|(1<<TXEN)
		out  UCSRB,temp1
		ret

		
		;*********************************************************************

U_WRITE: 
		ldi 	XFR,0x00
		rcall   CURSOR
		ldi		ZH, HIGH(2*TXT5)
		ldi		ZL, LOW(2*TXT5)
		rcall	LCDBLURB
		ldi 	XFR,0x40
		rcall   CURSOR
		ldi		ZH, HIGH(2*TXT6)
		ldi		ZL, LOW(2*TXT6)
		rcall	LCDBLURB


		ldi		XH,HIGH(0x0061)
		ldi		XL,LOW(0x0061)		

		ld      RECEIVE,X+	;Recupera Pagina High da scrivere 
		ldi 	XFR,0x0A
		rcall   CURSOR
		mov     XFR,RECEIVE
		rcall   DATA_LCD

		ld      RECEIVE,X+	
		ldi 	XFR,0x0B
		rcall   CURSOR
		mov     XFR,RECEIVE
		rcall   DATA_LCD

		ld      RECEIVE,X+	
		ldi 	XFR,0x0C
		rcall   CURSOR
		mov     XFR,RECEIVE
		rcall   DATA_LCD

		ld      RECEIVE,X+	
		ldi 	XFR,0x0D
		rcall   CURSOR
		mov     XFR,RECEIVE
		rcall   DATA_LCD

		ld      RECEIVE,X+	;Recupera numero dati da scrivere byte MSB
		ldi 	XFR,0x4A
		rcall   CURSOR
		mov     XFR,RECEIVE
		rcall   DATA_LCD

		ld      RECEIVE,X+	
		ldi 	XFR,0x4B
		rcall   CURSOR
		mov     XFR,RECEIVE
		rcall   DATA_LCD

		ld      RECEIVE,X+	
		ldi 	XFR,0x4C
		rcall   CURSOR
		mov     XFR,RECEIVE
		rcall   DATA_LCD

		ld      RECEIVE,X+	
		ldi 	XFR,0x4D
		rcall   CURSOR
		mov     XFR,RECEIVE
		rcall   DATA_LCD

		ld      RECEIVE,X+	
		ldi 	XFR,0x4E
		rcall   CURSOR
		mov     XFR,RECEIVE
		rcall   DATA_LCD

		ld      RECEIVE,X+	
		ldi 	XFR,0x4F
		rcall   CURSOR
		mov     XFR,RECEIVE
		rcall   DATA_LCD
		;*********************************************************************
		; Converti Numero Pagine da ASCII BCD in Binario
		;*********************************************************************
		ldi		XH,HIGH(0x0061)
		ldi		XL,LOW(0x0061)	
		ldi     cont, 3			;Numero Cifre Pagina - 1
		ld      temp,x+
		subi    temp,0x30
		mov     r0,temp
		clr     r1
U_RX10: clr     r4
		clr     r5
		ld      temp,x+
		subi    temp,0x30
		mov     r2,temp
		clr     r3
		clc     
		add     r4,r2
		adc     r5,r3
		lsl     r0
		rol     r1
		clc
		add     r4,r0
		adc     r5,r1
		lsl     r0
		rol     r1
		lsl     r0
		rol     r1
		clc
		add     r4,r0
		adc     r5,r1
		mov     r0,r4
		mov     r1,r5
		dec     cont
		brne    U_RX10
		mov     TEMP2,r1		;Salva la PAGINA in TEMP2:TEMP1
		mov     TEMP1,r0
;		mov     RECEIVE,r1	
;U_RX11: sbis    UCSRA,UDRE
;		rjmp    U_RX11
;		out  	UDR,RECEIVE
;		mov     RECEIVE,r0	
;U_RX12: sbis    UCSRA,UDRE
;		rjmp    U_RX12
;		out  	UDR,RECEIVE
		;*********************************************************************
		; Converti Numero Byte da ASCII BCD in Binario
		;*********************************************************************
		ldi     cont, 5			;Numero Cifre Byte - 1
		ld      temp,x+
		subi    temp,0x30
		mov     r0,temp
		clr     r1
		clr     r2
U_RX13: clr     r6
		clr     r7
		clr     r8
		ld      temp,x+
		subi    temp,0x30
		mov     r3,temp
		clr     r4
		clr     r5
		clc     
		add     r6,r3
		adc     r7,r4
		adc     r8,r5
		lsl     r0
		rol     r1
		rol     r2
		clc
		add     r6,r0
		adc     r7,r1
		adc     r8,r2
		lsl     r0
		rol     r1
		rol     r2
		lsl     r0
		rol     r1
		rol     r2
		clc
		add     r6,r0
		adc     r7,r1
		adc     r8,r2
		mov     r0,r6
		mov     r1,r7
		mov     r2,r8
		dec     cont
		brne    U_RX13
		mov     U_NUMDATL,r0  		;Salva il numero Byte in U_NUMDATH:U_NUMDATL (SOLO 65535 BYTE PER VOLTA !!!!)
        mov     U_NUMDATH,r1
;		mov     RECEIVE,r2			;r2 NON E' SALVATO 
;U_RX14: sbis    UCSRA,UDRE
;		rjmp    U_RX14
;		out  	UDR,RECEIVE
;		mov     RECEIVE,r1
;U_RX15: sbis    UCSRA,UDRE
;		rjmp    U_RX15
;		out  	UDR,RECEIVE
;		mov     RECEIVE,r0
;U_RX16: sbis    UCSRA,UDRE
;		rjmp    U_RX16
;		out  	UDR,RECEIVE
		;****************************************************
		;***          PREPARA LA SCRITTURA BUFFER 1       ***
		;****************************************************
		CALL DEL10M
		CBI  PORTA,3		;Azzero CS
		LDI  DATO,0x84		;OP code per scrittura su BUFFER 1
		CALL WR_BYTE
		LDI  DATO,0x00
		CALL WR_BYTE
		LDI  DATO,0x00
		CALL WR_BYTE
		LDI  DATO,0x00
		CALL WR_BYTE
		;****************************************************
		ldi     XH,high(0x0060)	  
		ldi     XL,low(0x0060)
		clr     U_CONT
		set     		;Setta il Flag T Scrittura in MEMORIA
		reti 

U_DATA_WRITE:
		;****************************************************
		IN   	DATO,UDR    ;Riceve i DATI
		;****************************************************
		;*      SCRIVE SULLA MEMORIA AT45DB001
		;*      rinviando "#" alla seriale
		;****************************************************
		CALL 	WR_BYTE
		CLC
		SUBI    U_NUMDATL,LOW(1)
		SBCI    U_NUMDATH,HIGH(1)
		BREQ    U_DATA_WRITE_STOP
		CLR     U_CONT
		SET     		;Setta il Flag T Scrittura in MEMORIA
		RETI

U_DATA_WRITE_STOP:
		SBI     PORTA,3			;Setta CS
		CALL    DEL10M
		CALL    DEL10M
		;******************************************************
		;***     TRASFERISCE IL BUFFER 1 NELLA MEMORIA      ***
		;******************************************************
		CBI     PORTA,3			;Azzera CS
		NOP
		LDI     DATO,0x83
		CALL    WR_BYTE
		MOV     DATO,TEMP2
		CALL    WR_BYTE
		MOV     DATO,TEMP1
		CALL    WR_BYTE
		LDI     DATO,0x00
		CALL    WR_BYTE
		CALL    DEL10M
		SBI     PORTA,3			;Setta CS
		CALL    DEL10M
		NOP
U_RX21: sbis    UCSRA,UDRE
		rjmp    U_RX21
		ldi     TEMP0,'#'		;Simbolo di fine scrittura
		out  	UDR,TEMP0
		clt     				;Azzera il Flag T Scrittura in MEMORIA
		clr     U_CONT
		ldi		XH,HIGH(0x0060)
		ldi		XL,LOW(0x0060)
		in      TEMP0,UDR		;ATTENZIONE legge la porta seriale eliminando
		reti 					;il simbolo memorizzato, consentendo la 
								;ripartenza corretta del parser.
								;*********************************************	
				

U_LEGGI: 
		ldi 	XFR,0x00
		rcall   CURSOR
		ldi		ZH, HIGH(2*TXT5)
		ldi		ZL, LOW(2*TXT5)
		rcall	LCDBLURB
		ldi 	XFR,0x40
		rcall   CURSOR
		ldi		ZH, HIGH(2*TXT6)		
		ldi		ZL, LOW(2*TXT6)			
		rcall	LCDBLURB				


		ldi		XH,HIGH(0x0061)
		ldi		XL,LOW(0x0061)		

		ld      RECEIVE,X+	;Recupera Pagina High da leggere 
		ldi 	XFR,0x0A
		rcall   CURSOR
		mov     XFR,RECEIVE
		rcall   DATA_LCD

		ld      RECEIVE,X+	
		ldi 	XFR,0x0B
		rcall   CURSOR
		mov     XFR,RECEIVE
		rcall   DATA_LCD

		ld      RECEIVE,X+	
		ldi 	XFR,0x0C
		rcall   CURSOR
		mov     XFR,RECEIVE
		rcall   DATA_LCD

		ld      RECEIVE,X+	
		ldi 	XFR,0x0D
		rcall   CURSOR
		mov     XFR,RECEIVE
		rcall   DATA_LCD

		ld      RECEIVE,X+	;Recupera numero dati da scrivere byte MSB
		ldi 	XFR,0x4A
		rcall   CURSOR
		mov     XFR,RECEIVE
		rcall   DATA_LCD

		ld      RECEIVE,X+	
		ldi 	XFR,0x4B
		rcall   CURSOR
		mov     XFR,RECEIVE
		rcall   DATA_LCD

		ld      RECEIVE,X+	
		ldi 	XFR,0x4C
		rcall   CURSOR
		mov     XFR,RECEIVE
		rcall   DATA_LCD

		ld      RECEIVE,X+	
		ldi 	XFR,0x4D
		rcall   CURSOR
		mov     XFR,RECEIVE
		rcall   DATA_LCD

		ld      RECEIVE,X+	
		ldi 	XFR,0x4E
		rcall   CURSOR
		mov     XFR,RECEIVE
		rcall   DATA_LCD

		ld      RECEIVE,X+	
		ldi 	XFR,0x4F
		rcall   CURSOR
		mov     XFR,RECEIVE
		rcall   DATA_LCD
		;*********************************************************************
		; Converti Numero Pagine da ASCII BCD in Binario
		;*********************************************************************
		ldi		XH,HIGH(0x0061)
		ldi		XL,LOW(0x0061)	
		ldi     cont, 3			;Numero Cifre Pagina - 1
		ld      temp,x+
		subi    temp,0x30
		mov     r0,temp
		clr     r1
U_TX10: clr     r4
		clr     r5
		ld      temp,x+
		subi    temp,0x30
		mov     r2,temp
		clr     r3
		clc     
		add     r4,r2
		adc     r5,r3
		lsl     r0
		rol     r1
		clc
		add     r4,r0
		adc     r5,r1
		lsl     r0
		rol     r1
		lsl     r0
		rol     r1
		clc
		add     r4,r0
		adc     r5,r1
		mov     r0,r4
		mov     r1,r5
		dec     cont
		brne    U_TX10
		mov     DATMSB,r1		;Salva la PAGINA in DATMSB:DATLSB
		mov     DATLSB,r0
		;*********************************************************************
		; Converti Numero Byte da ASCII BCD in Binario
		;*********************************************************************
		ldi     cont, 5			;Numero Cifre Byte - 1
		ld      temp,x+
		subi    temp,0x30
		mov     r0,temp
		clr     r1
		clr     r2
U_TX13: clr     r6
		clr     r7
		clr     r8
		ld      temp,x+
		subi    temp,0x30
		mov     r3,temp
		clr     r4
		clr     r5
		clc     
		add     r6,r3
		adc     r7,r4
		adc     r8,r5
		lsl     r0
		rol     r1
		rol     r2
		clc
		add     r6,r0
		adc     r7,r1
		adc     r8,r2
		lsl     r0
		rol     r1
		rol     r2
		lsl     r0
		rol     r1
		rol     r2
		clc
		add     r6,r0
		adc     r7,r1
		adc     r8,r2
		mov     r0,r6
		mov     r1,r7
		mov     r2,r8
		dec     cont
		brne    U_TX13
		mov     TEMP2,r2    		;Salva il numero Byte in TEMP2:TEMP1:TEMP0
		mov     TEMP1,r1
		mov     TEMP0,r0
		;****************************************************
		;***       PREPARA LA LETTURA DELLA MEMORIA       ***
		;****************************************************
		CALL DEL10M
		CBI  PORTA,3		;Azzero CS
		LDI  DATO,0xE8		;OP code per lettura dalla main memory
		CALL WR_BYTE
		MOV  DATO,DATMSB
		CALL WR_BYTE
		MOV  DATO,DATLSB
		CALL WR_BYTE
		LDI  DATO,0x00
		CALL WR_BYTE
		LDI  DATO,0x00		;Scrive 4 byte di don't care
		CALL WR_BYTE
		LDI  DATO,0x00
		CALL WR_BYTE
		LDI  DATO,0x00
		CALL WR_BYTE
		LDI  DATO,0x00
		CALL WR_BYTE

		;SBI  PORTA,0		;**********
		;NOP					;**********
		;CBI  PORTA,0		;**********
		;NOP					;**********
		nop
		nop
		nop
		nop
		;****************************************************
		;*      LEGGE DALLA MEMORIA AT45DB001
		;*      rinviando "#" alla seriale
		;****************************************************
U_TX19:	NOP
		NOP
		CALL    RD_BYTE
U_TX20: SBIS    UCSRA,UDRE
		RJMP    U_TX20
		OUT     UDR,DATO		
		CALL    DEL10M
		CLC
		SUBI    TEMP0,LOW(1)
		SBCI    TEMP1,BYTE2(1)
		SBCI    TEMP2,BYTE3(1)
		LDI     TEMP,0x00
		CLC
		CP      TEMP0,TEMP
		CPC     TEMP1,TEMP
		CPC     TEMP2,TEMP
		BRNE    U_TX19
		NOP
		SBI     PORTA,3			;Attiva CS
		NOP
U_TX21: sbis    UCSRA,UDRE
		rjmp    U_TX21
		ldi     TEMP0,'#'		;Simbolo di fine scrittura
		out  	UDR,TEMP0
		clt     				;Azzera il Flag T Scrittura in MEMORIA
		clr     U_CONT
		ldi		XH,HIGH(0x0060)
		ldi		XL,LOW(0x0060)
		in      TEMP0,UDR		;ATTENZIONE legge la porta seriale eliminando
		reti 					;il simbolo memorizzato, consentendo la 
								;ripartenza corretta del parser.
								;*********************************************	
		reti


U_AUDIO: 
		ldi 	XFR,0x00
		rcall   CURSOR
		ldi		ZH, HIGH(2*TXT5)
		ldi		ZL, LOW(2*TXT5)
		rcall	LCDBLURB
		ldi 	XFR,0x40
		rcall   CURSOR
		ldi		ZH, HIGH(2*TXT6)		
		ldi		ZL, LOW(2*TXT6)			
		rcall	LCDBLURB				


		ldi		XH,HIGH(0x0061)
		ldi		XL,LOW(0x0061)		

		ld      RECEIVE,X+	;Recupera Pagina High da leggere 
		ldi 	XFR,0x0A
		rcall   CURSOR
		mov     XFR,RECEIVE
		rcall   DATA_LCD

		ld      RECEIVE,X+	
		ldi 	XFR,0x0B
		rcall   CURSOR
		mov     XFR,RECEIVE
		rcall   DATA_LCD

		ld      RECEIVE,X+	
		ldi 	XFR,0x0C
		rcall   CURSOR
		mov     XFR,RECEIVE
		rcall   DATA_LCD

		ld      RECEIVE,X+	
		ldi 	XFR,0x0D
		rcall   CURSOR
		mov     XFR,RECEIVE
		rcall   DATA_LCD

		ld      RECEIVE,X+	;Recupera numero dati da scrivere byte MSB
		ldi 	XFR,0x4A
		rcall   CURSOR
		mov     XFR,RECEIVE
		rcall   DATA_LCD

		ld      RECEIVE,X+	
		ldi 	XFR,0x4B
		rcall   CURSOR
		mov     XFR,RECEIVE
		rcall   DATA_LCD

		ld      RECEIVE,X+	
		ldi 	XFR,0x4C
		rcall   CURSOR
		mov     XFR,RECEIVE
		rcall   DATA_LCD

		ld      RECEIVE,X+	
		ldi 	XFR,0x4D
		rcall   CURSOR
		mov     XFR,RECEIVE
		rcall   DATA_LCD

		ld      RECEIVE,X+	
		ldi 	XFR,0x4E
		rcall   CURSOR
		mov     XFR,RECEIVE
		rcall   DATA_LCD

		ld      RECEIVE,X+	
		ldi 	XFR,0x4F
		rcall   CURSOR
		mov     XFR,RECEIVE
		rcall   DATA_LCD
		;*********************************************************************
		; Converti Numero Pagine da ASCII BCD in Binario
		;*********************************************************************
		ldi		XH,HIGH(0x0061)
		ldi		XL,LOW(0x0061)	
		ldi     cont, 3			;Numero Cifre Pagina - 1
		ld      temp,x+
		subi    temp,0x30
		mov     r0,temp
		clr     r1
U_AX10: clr     r4
		clr     r5
		ld      temp,x+
		subi    temp,0x30
		mov     r2,temp
		clr     r3
		clc     
		add     r4,r2
		adc     r5,r3
		lsl     r0
		rol     r1
		clc
		add     r4,r0
		adc     r5,r1
		lsl     r0
		rol     r1
		lsl     r0
		rol     r1
		clc
		add     r4,r0
		adc     r5,r1
		mov     r0,r4
		mov     r1,r5
		dec     cont
		brne    U_AX10
		mov     DATMSB,r1		;Salva la PAGINA in DATMSB:DATLSB
		mov     DATLSB,r0
		;*********************************************************************
		; Converti Numero Byte da ASCII BCD in Binario
		;*********************************************************************
		ldi     cont, 5			;Numero Cifre Byte - 1
		ld      temp,x+
		subi    temp,0x30
		mov     r0,temp
		clr     r1
		clr     r2
U_AX13: clr     r6
		clr     r7
		clr     r8
		ld      temp,x+
		subi    temp,0x30
		mov     r3,temp
		clr     r4
		clr     r5
		clc     
		add     r6,r3
		adc     r7,r4
		adc     r8,r5
		lsl     r0
		rol     r1
		rol     r2
		clc
		add     r6,r0
		adc     r7,r1
		adc     r8,r2
		lsl     r0
		rol     r1
		rol     r2
		lsl     r0
		rol     r1
		rol     r2
		clc
		add     r6,r0
		adc     r7,r1
		adc     r8,r2
		mov     r0,r6
		mov     r1,r7
		mov     r2,r8
		dec     cont
		brne    U_AX13
		mov     TEMP2,r2    		;Salva il numero Byte in TEMP2:TEMP1:TEMP0
		mov     TEMP1,r1
		mov     TEMP0,r0
		;****************************************************
		;***       PREPARA LA LETTURA DELLA MEMORIA       ***
		;****************************************************
		CALL DEL10M
		CBI  PORTA,3		;Azzero CS
		LDI  DATO,0xE8		;OP code per lettura dalla main memory
		CALL WR_BYTE
		MOV  DATO,DATMSB
		CALL WR_BYTE
		MOV  DATO,DATLSB
		CALL WR_BYTE
		LDI  DATO,0x00
		CALL WR_BYTE
		LDI  DATO,0x00		;Scrive 4 byte di don't care
		CALL WR_BYTE
		LDI  DATO,0x00
		CALL WR_BYTE
		LDI  DATO,0x00
		CALL WR_BYTE
		LDI  DATO,0x00
		CALL WR_BYTE

	
		nop
		nop
		nop
		nop
		;****************************************************
		;*      LEGGE DALLA MEMORIA AT45DB001
		;*      rinviando "#" alla seriale
		;****************************************************
U_AX19:	NOP
		NOP
		CALL    RD_BYTE
		OUT     PORTB,DATO		
		CALL    DEL100U
		CLC
		SUBI    TEMP0,LOW(1)
		SBCI    TEMP1,BYTE2(1)
		SBCI    TEMP2,BYTE3(1)
		LDI     TEMP,0x00
		CLC
		CP      TEMP0,TEMP
		CPC     TEMP1,TEMP
		CPC     TEMP2,TEMP
		BRNE    U_AX19
		NOP
		SBI     PORTA,3			;Attiva CS
		NOP
U_AX21: sbis    UCSRA,UDRE
		rjmp    U_AX21
		ldi     TEMP0,'#'		;Simbolo di fine scrittura
		out  	UDR,TEMP0
		clt     				;Azzera il Flag T Scrittura in MEMORIA
		clr     U_CONT
		ldi		XH,HIGH(0x0060)
		ldi		XL,LOW(0x0060)
		in      TEMP0,UDR		;ATTENZIONE legge la porta seriale eliminando
		reti 					;il simbolo memorizzato, consentendo la 
								;ripartenza corretta del parser.
								;*********************************************	
		reti




U_RESET:
		ld      RECEIVE,X+		;Controlla se la cella 0x61 = 'R'
		cpi     RECEIVE,'R'
		brne    U_DEC32
		ld      RECEIVE,X+		;Controlla se la cella 0x62 = 'R'
		cpi     RECEIVE,'R'
		brne    U_DEC32
		ld      RECEIVE,X+		;Controlla se la cella 0x63 = 'R'
		cpi     RECEIVE,'R'
		brne    U_DEC32
		ld      RECEIVE,X+		;Controlla se la cella 0x64 = 'R'
		cpi     RECEIVE,'R'
		brne    U_DEC32
		ld      RECEIVE,X+		;Controlla se la cella 0x65 = 'R'
		cpi     RECEIVE,'R'
		brne    U_DEC32
		ld      RECEIVE,X+		;Controlla se la cella 0x66 = 'R'
		cpi     RECEIVE,'R'
		brne    U_DEC32
		ld      RECEIVE,X+		;Controlla se la cella 0x67 = 'R'
		cpi     RECEIVE,'R'
		brne    U_DEC32
		ld      RECEIVE,X+		;Controlla se la cella 0x68 = 'R'
		cpi     RECEIVE,'R'
		brne    U_DEC32
		ld      RECEIVE,X+		;Controlla se la cella 0x69 = 'R'
		cpi     RECEIVE,'R'
		brne    U_DEC32
		ld      RECEIVE,X+		;Controlla se la cella 0x6A = 'R'
		cpi     RECEIVE,'R'
		brne    U_DEC32
		nop
		ldi 	XFR,0x00
		rcall   CURSOR
		ldi		ZH, HIGH(2*TXT3)
		ldi		ZL, LOW(2*TXT3)
		rcall	LCDBLURB
		ldi 	XFR,0x40
		rcall   CURSOR
		ldi		ZH, HIGH(2*TXT4)
		ldi		ZL, LOW(2*TXT4)
		rcall	LCDBLURB
        nop						;Se tutte le lettere sono uguali a 'R'
U_DEC31:sbis    UCSRA,UDRE		;scrive sulla porta seriale il simbolo
		rjmp    U_DEC31         ;'*' di corretto RESET
		ldi     TEMP0,'*'
		out  	UDR,TEMP0
U_DEC32:ldi     XH,high(0x0060)	;Se non tutte le lettere sono uguali a 'R'  
		ldi     XL,low(0x0060)  ;esce ripristinando il puntatore della RAM 
		clr     U_CONT			;all'inizio, azzera U_CONT e il Flag T.
		clt         			;*********************************************
		in      TEMP0,UDR		;ATTENZIONE legge la porta seriale eliminando
		reti 					;il simbolo 'R' memorizzato, consentendo la 
								;ripartenza corretta del parser.
								;*********************************************
U_SILENZIO:
		ld      RECEIVE,X+		;Controlla se la cella 0x61 = 'Z'
		cpi     RECEIVE,'Z'
		brne    U_DEC92
		ld      RECEIVE,X+		;Controlla se la cella 0x62 = 'Z'
		cpi     RECEIVE,'Z'
		brne    U_DEC92
		ld      RECEIVE,X+		;Controlla se la cella 0x63 = 'Z'
		cpi     RECEIVE,'Z'
		brne    U_DEC92
		ld      RECEIVE,X+		;Controlla se la cella 0x64 = 'Z'
		cpi     RECEIVE,'Z'
		brne    U_DEC92
		ld      RECEIVE,X+		;Controlla se la cella 0x65 = 'Z'
		cpi     RECEIVE,'Z'
		brne    U_DEC92
		ld      RECEIVE,X+		;Controlla se la cella 0x66 = 'Z'
		cpi     RECEIVE,'Z'
		brne    U_DEC92
		ld      RECEIVE,X+		;Controlla se la cella 0x67 = 'Z'
		cpi     RECEIVE,'Z'
		brne    U_DEC92
		ld      RECEIVE,X+		;Controlla se la cella 0x68 = 'Z'
		cpi     RECEIVE,'Z'
		brne    U_DEC92
		ld      RECEIVE,X+		;Controlla se la cella 0x69 = 'Z'
		cpi     RECEIVE,'Z'
		brne    U_DEC92
		ld      RECEIVE,X+		;Controlla se la cella 0x6A = 'Z'
		cpi     RECEIVE,'Z'
		brne    U_DEC92
		nop
		ldi 	XFR,0x00
		rcall   CURSOR
		ldi		ZH, HIGH(2*TXT3)
		ldi		ZL, LOW(2*TXT3)
		rcall	LCDBLURB
		ldi 	XFR,0x40
		rcall   CURSOR
		ldi		ZH, HIGH(2*TXT9)
		ldi		ZL, LOW(2*TXT9)
		rcall	LCDBLURB
		nop
		call    MEM_SILENZIO	;Richiama la routine che scrive 0x80 nella memoria
        nop						;Se tutte le lettere sono uguali a 'Z'
U_DEC91:sbis    UCSRA,UDRE		;scrive sulla porta seriale il simbolo
		rjmp    U_DEC91         ;'*' di corretto SILENZIO
		ldi     TEMP0,'*'
		out  	UDR,TEMP0
U_DEC92:ldi     XH,high(0x0060)	;Se non tutte le lettere sono uguali a 'Z'  
		ldi     XL,low(0x0060)  ;esce ripristinando il puntatore della RAM 
		clr     U_CONT			;all'inizio, azzera U_CONT e il Flag T.
		clt         			;*********************************************
		in      TEMP0,UDR		;ATTENZIONE legge la porta seriale eliminando
		reti 					;il simbolo 'Z' memorizzato, consentendo la 
								;ripartenza corretta del parser.
								;*********************************************
MEM_SILENZIO:
		ldi     TEMP2,HIGH(2047)
		ldi     TEMP1,LOW(2047)
MEM_SILENZIO_BUFFER1:
		;******* PREPARA LA SCRITTURA DEL BUFFER1 ******************
		CALL DEL10M
		CBI  PORTA,3		;Azzero CS
		LDI  DATO,0x84		;OP code per scrittura su BUFFER 1
		CALL WR_BYTE
		LDI  DATO,0x00
		CALL WR_BYTE
		LDI  DATO,0x00
		CALL WR_BYTE
		LDI  DATO,0x00
		CALL WR_BYTE
		;****************************************************
		;****************************************************
		ldi     DATO,0X80    ;carica 0X80 SILENZIO
		ldi     U_NUMDATL,LOW(256)
		ldi     U_NUMDATH,HIGH(256)

		;****************************************************
		;*      SCRIVE SULLA MEMORIA AT45DB001
		;*      rinviando "#" alla seriale
		;****************************************************
U_SILENZIO_LOOP:
		ldi     DATO,0X80    ;carica 0X80 SILENZIO
		CALL 	WR_BYTE
		CLC
		SUBI    U_NUMDATL,LOW(1)
		SBCI    U_NUMDATH,HIGH(1)
		BREQ    U_DATA2_WRITE_STOP
		JMP     U_SILENZIO_LOOP


U_DATA2_WRITE_STOP:
		SBI     PORTA,3			;Setta CS
		CALL    DEL10M
		CALL    DEL10M
		;******************************************************
		;***     TRASFERISCE IL BUFFER 1 NELLA MEMORIA      ***
		;******************************************************
		CBI     PORTA,3			;Azzera CS
		NOP
		LDI     DATO,0x83
		CALL    WR_BYTE
		MOV     DATO,TEMP2
		CALL    WR_BYTE
		MOV     DATO,TEMP1
		CALL    WR_BYTE
		LDI     DATO,0x00
		CALL    WR_BYTE
		CALL    DEL10M
		SBI     PORTA,3			;Setta CS
		CALL    DEL10M
		NOP

		CLC
		SUBI    TEMP1,LOW(1)
		SBCI    TEMP2,HIGH(1)
		BREQ    U_SILENZIO_WRITE_STOP
		JMP     MEM_SILENZIO_BUFFER1

U_SILENZIO_WRITE_STOP:
U_RX91: sbis    UCSRA,UDRE
		rjmp    U_RX91
		ldi     TEMP0,'#'		;Simbolo di fine scrittura
		out  	UDR,TEMP0
		ret

;***********************************************************************************************


U_MEM:
		ld      RECEIVE,X+		;Controlla se la cella 0x61 = 'T'
		cpi     RECEIVE,'T'
		brne    U_DEC42
		ld      RECEIVE,X+		;Controlla se la cella 0x62 = 'T'
		cpi     RECEIVE,'T'
		brne    U_DEC42
		ld      RECEIVE,X+		;Controlla se la cella 0x63 = 'T'
		cpi     RECEIVE,'T'
		brne    U_DEC42
		ld      RECEIVE,X+		;Controlla se la cella 0x64 = 'T'
		cpi     RECEIVE,'T'
		brne    U_DEC42
		ld      RECEIVE,X+		;Controlla se la cella 0x65 = 'T'
		cpi     RECEIVE,'T'
		brne    U_DEC42
		ld      RECEIVE,X+		;Controlla se la cella 0x66 = 'T'
		cpi     RECEIVE,'T'
		brne    U_DEC42
		ld      RECEIVE,X+		;Controlla se la cella 0x67 = 'T'
		cpi     RECEIVE,'T'
		brne    U_DEC42
		ld      RECEIVE,X+		;Controlla se la cella 0x68 = 'T'
		cpi     RECEIVE,'T'
		brne    U_DEC42
		ld      RECEIVE,X+		;Controlla se la cella 0x69 = 'T'
		cpi     RECEIVE,'T'
		brne    U_DEC42
		ld      RECEIVE,X+		;Controlla se la cella 0x6A = 'T'
		cpi     RECEIVE,'T'
		brne    U_DEC42
		nop
		ldi 	XFR,0x00
		rcall   CURSOR
		ldi		ZH, HIGH(2*TXT3)
		ldi		ZL, LOW(2*TXT3)
		rcall	LCDBLURB
		ldi 	XFR,0x40
		rcall   CURSOR
		ldi		ZH, HIGH(2*TXT7)
		ldi		ZL, LOW(2*TXT7)
		rcall	LCDBLURB
		nop
		call    MEM_STATO		;Richiama la routine che legge lo stato della memoria
        nop						;Se tutte le lettere sono uguali a 'T'
U_DEC41:sbis    UCSRA,UDRE		;scrive sulla porta seriale il simbolo
		rjmp    U_DEC41         ;'*' di corretto RESET
		ldi     TEMP0,'*'
		out  	UDR,TEMP0
U_DEC42:ldi     XH,high(0x0060)	;Se non tutte le lettere sono uguali a 'T'  
		ldi     XL,low(0x0060)  ;esce ripristinando il puntatore della RAM 
		clr     U_CONT			;all'inizio, azzera U_CONT e il Flag T.
		clt         			;*********************************************
		in      TEMP0,UDR		;ATTENZIONE legge la porta seriale eliminando
		reti 					;il simbolo 'T' memorizzato, consentendo la 
								;ripartenza corretta del parser.
								;*********************************************

U_PROG:
		ld      RECEIVE,X+		;Controlla se la cella 0x61 = 'P'
		cpi     RECEIVE,'P'
		brne    U_DEC42
		ld      RECEIVE,X+		;Controlla se la cella 0x62 = 'P'
		cpi     RECEIVE,'P'
		brne    U_DEC42
		ld      RECEIVE,X+		;Controlla se la cella 0x63 = 'P'
		cpi     RECEIVE,'P'
		brne    U_DEC42
		ld      RECEIVE,X+		;Controlla se la cella 0x64 = 'P'
		cpi     RECEIVE,'P'
		brne    U_DEC42
		ld      RECEIVE,X+		;Controlla se la cella 0x65 = 'P'
		cpi     RECEIVE,'P'
		brne    U_DEC42
		ld      RECEIVE,X+		;Controlla se la cella 0x66 = 'P'
		cpi     RECEIVE,'P'
		brne    U_DEC42
		ld      RECEIVE,X+		;Controlla se la cella 0x67 = 'P'
		cpi     RECEIVE,'P'
		brne    U_DEC42
		ld      RECEIVE,X+		;Controlla se la cella 0x68 = 'P'
		cpi     RECEIVE,'P'
		brne    U_DEC42
		ld      RECEIVE,X+		;Controlla se la cella 0x69 = 'P'
		cpi     RECEIVE,'P'
		brne    U_DEC42
		ld      RECEIVE,X+		;Controlla se la cella 0x6A = 'P'
		cpi     RECEIVE,'P'
		brne    U_DEC44
		nop
		ldi 	XFR,0x00
		rcall   CURSOR
		ldi		ZH, HIGH(2*TXT3)
		ldi		ZL, LOW(2*TXT3)
		rcall	LCDBLURB
		ldi 	XFR,0x40
		rcall   CURSOR
		ldi		ZH, HIGH(2*TXT8)
		ldi		ZL, LOW(2*TXT8)
		rcall	LCDBLURB
		nop
		call    MEM_PROG		;Richiama la routine che legge lo stato della memoria
        nop						;Se tutte le lettere sono uguali a 'T'
U_DEC43:sbis    UCSRA,UDRE		;scrive sulla porta seriale il simbolo
		rjmp    U_DEC43         ;'*' di corretto RESET
		ldi     TEMP0,'*'
		out  	UDR,TEMP0
U_DEC44:ldi     XH,high(0x0060)	;Se non tutte le lettere sono uguali a 'T'  
		ldi     XL,low(0x0060)  ;esce ripristinando il puntatore della RAM 
		clr     U_CONT			;all'inizio, azzera U_CONT e il Flag T.
		clt         			;*********************************************
		in      TEMP0,UDR		;ATTENZIONE legge la porta seriale eliminando
		reti 					;il simbolo 'T' memorizzato, consentendo la 
								;ripartenza corretta del parser.
								;*********************************************




		

	;**********************************************************************
	; FUNCTION  BIN2BCD
	;
	;**********************************************************************     



  ;********************************************************************
  ;		 FUNCTION
  ;      Display Sign-On Message
  ;  ============================
		  

LCDBLURB:
			nop
			;ldi		ZH, HIGH(2*TXT)
			;ldi		ZL, LOW(2*TXT)
L3A:    	lpm                       ;from prog mem into R0
			mov		XFR, R0
			tst		XFR
			brne	L3B
			rjmp	L4
L3B:    	cpi     XFR, 0x0D      ;Look for CR in message (new line)
			brne	L3C
        	ldi     XFR, 0x40      ;Cursor to position 0x40, start of 2nd line
			call	del450n
        	rcall   CMD_LCD        ;Sends command
			rjmp	L3D
			call	del450n
L3C:		rcall	DATA_LCD
L3D:    	adiw    ZL, 1	       ;Increment pointer. This neat instruction does
        	rjmp    L3A      	   ;w16 bit addition to pointer ZHI:ZLO.
L4:         call	del450n

        	ret	                   

TXT1:		.DB	" ITIS Q. Sella ",0x00
TXT2:		.DB "      2009     ",0x00
TXT3:		.DB	"    MEMORIA    ",0x00
TXT4:		.DB "               ",0x00
TXT7:		.DB "  STATUS       ",0x00
TXT5:		.DB	"PAGINA  =      ",0x00
TXT6:		.DB "CAMPIONI=      ",0x00
TXT8:		.DB "PROG 256 byte  ",0x00
TXT9:		.DB "SILENZIO       ",0x00



; The message should contain an even number of bytes in each line (including
; the terminator) or the compiler becomes confused. If there are more than 16
; characters per line,the ones on the right will not be visible in this mode,
; unless you use a larger display. This type of display comes in sizes of 1
; or 2 rows of 16 or more characters.
; The address of the first character in each row is 0 (first row) or
; 64 (second row),irrespective of the size of the display.

;****************************************************************************
; FUNCTION

;       Sends a control function to the display
;       =========================================

;       Used for clearing the display, moving the cursor etc.
;       Command arrives in XFR. XFR is restored.

CMD_LCD:

			push	XFR
			mov		TEMP, XFR
			nop
			andi	XFR, 0xF0			;Mask off lower 4 bits
			sbr		XFR, OE         	;OE bit high
			out		PORTC, XFR			;Send upper 4 bits to display
			nop							;Brief delay to give reasonable OE
			nop							;pulse width
			cbi		PORTC,E         	;OE goes low to clock in data
			mov		XFR, TEMP			;Get data back
			swap    XFR					;Lower 4 bits
			andi	XFR, 0xF0
			sbr		XFR, OE				;OE high
        	out     PORTC, XFR          ;Write lower 4 bits to LCD
			nop
			nop
			nop
			cbi		PORTC,E 			;OE clock low
		    rcall	WAIT75US    		;50 usec approx  
			pop		XFR
			ret


;******************************************************************************
; FUNCTION

;       Display an ASCII character on the display
;       =========================================

;       Displays data arriving in XFR at the cursor location.
;       XFR and TEMP are restored.

DATA_LCD:

			push	XFR
			push	TEMP
			mov		TEMP, XFR
			andi	XFR, 0xF0			;Mask off lower 4 bits
			sbr		XFR, OE				;OE bit high
			sbr		XFR, RS1			;Data/command bit high
			out		PORTC, XFR			;Write upper 4 bits to display
			nop	
			nop						;Brief delay
			nop
			cbi		PORTC,E 			;OE low to clock data
			swap	TEMP				;Lower 4 bits
			andi	TEMP, 0xF0			;Masked off
			sbr		TEMP, OE			;OE high
			sbr		TEMP, RS1
			out		PORTC, TEMP			;Lower 4 bits to LCD
			nop	
			nop
			nop	
			cbi		PORTC,E 			;OE low to clock data
		    rcall	WAIT75US    		;50 usec approx  
			pop     TEMP
			pop		XFR
        	ret

;****************************************************************************
; FUNCTION

;       Moves the LCD display cursor
;       ============================

;       Next char will be placed at the new cursor location.
;       Address arrives in XFR, which is destroyed.

;       Note:   LCD addresses start at 0 (top left) and 0x40 (bottom left)
;               and increment left to right. Range is 0 - 0x7F. Obviously
;               many addresses won't be usable/visible on 16 col displays.

;       Address command is 0b1aaaaaaa where aaaaaaa is the address.

CURSOR:

			ori		XFR, 0x80			;Set MSB for address command
			nop
			rcall	CMD_LCD
			nop
			ret

;****************************************************************************
; FUNCTION

;       Clears the LCD display and restores the cursor to start
;       =======================================================

;       XFR is destroyed.


CLEAR:

			ldi		XFR, display_clear
			nop
			rcall	CMD_LCD
			rcall	WAIT2MS
			rcall	WAIT2MS
			ret



;****************************************************************************
; FUNCTION

;       Prints packed BCD byte on LCD display in ASCII
;       ==============================================

;       XFR contains the byte. Two ASCII chars are printed, MSB and LSB
;       XFR is restored.
;       LCD cursor should be positioned correctly before call
;       This routine will also correctly display a binary byte as
;       two chars of HEX-ASCII


PRINTB:

			push	XFR
			andi	XFR, 0xF0		;Only upper nibble
			swap	XFR
			ori     XFR,0x30	
			rcall	DATA_LCD
			nop
			nop
			pop		XFR				;Get data again
			push	XFR
			andi	XFR, 0x0F		;Only lower nibble
			ori     XFR,0x30		;XFR conv to ASCII
			rcall	DATA_LCD
			nop
			nop
			pop	    XFR
			ret


; ASCII CONVERSION

; Arrive with binary in low nibble of XFR (high nibble is ignored)
; Return with ASCII result in XFR. For both nibbles to be converted,
; then use the "swap" command and call ASCII again.
 

ASCII:		push	TEMP
        	cbr     XFR, 0xF0       ;clear MSBs just in case
        	cpi     XFR, 0x00       ;sets carry if XFR is smaller than 0x0A
        	brcs    ASCII2          ;to do the numbers
       	    ldi     TEMP, 0x37      ;magic number for A - F
			rjmp	ASCII3
ASCII2: 	ldi     TEMP, 0x30      ;magic number for 0 - 9
ASCII3: 	add     XFR, TEMP       ;to make ASCII
			pop		TEMP
			ret


; DELAY ROUTINES


WAIT75US:

			ldi     TEMP0, 2
D1:			ldi     TEMP1, 255
D2:			dec     TEMP1
			brne    D2   
			dec     TEMP0
			brne    D1
			ret
			
			
WAIT2MS:

			ldi     TEMP0, 50
D3:			ldi     TEMP1, 255
D4:			dec     TEMP1
			brne    D4   
			dec     TEMP0
			brne    D3
			ret			
			 

WAIT20MS:

			ldi     TEMP0, 3
D5:			ldi     TEMP1, 255
D6:         ldi     TEMP2, 255
D7:			dec     TEMP2
			brne    D7
			dec     TEMP1
			brne    D6
			dec     TEMP0
			brne    D5
			ret

WAITXXMS:

			ldi     TEMP0, 255
D8:			ldi     TEMP1, 255
D9:         ldi     TEMP2, 255
D10:		dec     TEMP2
			brne    D10
			dec     TEMP1
			brne    D9
			dec     TEMP0
			brne    D8
			ret

;*************** ROUTINES THAILANDESI controllo LCD ************************** 

; initial lcd

init_lcd:   call   del15m             ; Power on delay,wait lcd controller
		    ldi    r16,0x30
		    call   write_ir              
            call   del4m1  
			call   del4m1         
            ldi    r16,0x30
		    call   write_ir
            call   del100u
            ldi    r16,0x30
		    call   write_ir
            call   del100u
		    ldi    r16,0x20
		    call   write_ir
            call   del100u
		    ldi    r16,0x28
		    call   write_ir
            call   del100u
            ldi    r16,0x08
		    call   write_ir                 
            call   del100u
		    ldi    r16,0x01
		    call   write_ir
            call   del1m6
		    ldi    r16,0x06
		    call   write_ir
            call   del100u
			call   display_on         ; turn on display
            ret

; write data to instruction register
write_ir:   
			call   del450n
			cbi    LCD_PORT,RS
			call   del450n
            call   write_lcd
            ret
		  
; write data to data reguster
write_dr: 
			call   del450n
			sbi    LCD_PORT,RS
			call   del450n
            call   write_lcd
            ret
		   	
; write data 4 bit to lcd							    
write_lcd:  push   r17
            push   r16  
            andi   r16,0xf0
            mov    r17,r16
		    in     r16,LCD_PORT
		    andi   r16,0x0f
		    or     r16,r17
		    out    LCD_PORT,r16
		    sbi    LCD_PORT,E
			call   del450n
		    cbi    LCD_PORT,E
			call   del450n
            pop    r16
            swap   r16
            mov    r17,r16
		    in     r16,LCD_PORT
		    andi   r16,0x0f
		    or     r16,r17
            out    LCD_PORT,r16
		    sbi    LCD_PORT,E
			call   del450n
		    cbi    LCD_PORT,E
			call   del450n
            pop    r17 
		    ret

; display on           
display_on: ldi    r16,0x0C
            call   write_ir 
			call   del100u               
            ret

; set ddram address
set_ddram:  ori    r16,0x80
            call   write_ir
			call   del100u 
            ret
            
; put char
putc:       call   del450n
			call   write_dr
            call   del100u
            ret 

; delay 450ns
del450n:    push   r18
            ldi    r18,4
w450n:	    dec    r18
			brne   w450n
            pop    r18
			ret
 
            
; delay 40us
del40u:     push   r18        
            ldi    r18,224    
w40u:       dec    r18         
			brne   w40u       
			pop    r18          
            ret
			               
; delay 100us
del100u:    push   r18
            push   r19
			ldi    r18,2
w100u_2:	ldi    r19,255
w100u_1:	dec    r19
			brne   w100u_1 
            dec    r18
			brne   w100u_2
			pop    r19
			pop    r18
			ret

; delay 1.6ms
del1m6:     push   r18        
            push   r19        
            ldi    r18,33     
w1m6_2:		ldi    r19,255    
w1m6_1:	    dec    r19               
			brne   w1m6_1     
			dec    r18        
			brne   w1m6_2     
			pop    r19        
			pop    r18       
            ret     
			
; delay 4.1ms
del4m1:     push   r18
            push   r19
			ldi    r18,86
w4m1_2:	    ldi    r19,255
w4m1_1:     dec    r19
            brne   w4m1_1 
			dec    r18
			brne   w4m1_2             
			pop    r19
			pop    r18
			ret
; delay 10ms
del10m:     push   r18
            push   r19
			ldi    r18,230
w10m_2:	    ldi    r19,230
w10m_1:     dec    r19
            brne   w10m_1 
			dec    r18
			brne   w10m_2             
			pop    r19
			pop    r18
			ret
     
; delay 15 ms
del15m:     push   r18        
            push   r19       
            push   r20
			ldi    r18,2     
w15m_3:	    ldi    r19,255                             
w15m_2:	    ldi    r20,255                
w15m_1:     dec    r20       
			brne   w15m_1     
			dec    r19        
			brne   w15m_2     
			dec    r18
			brne   w15m_3
			pop    r20
			pop    r19         
			pop    r18        
            ret              

			;******************************************************************************
			;------------------------------------------------------------------------------
			;	Programma per la scrittura e lettura dei dati da una memoria flash
			;	AT45DB041D		4 Megabit  seriale
			;
			;	Usa la porta A per azionare la memoria
			;	Usa la porta D per visualizzare un byte
			;	Collegamenti:
			;	SCK  -> bit 0
			;	SOUT -> bit 1
			;	Sin  -> bit 2
			;	CS   -> bit 3
			;
			;   Ugo  2009
			;------------------------------------------------------------------------------

			;.def	cont		= r20
			;.def	dato		= r21
			;.def	temp		= r22
			;.def	contB		= r23

			;---------------------------------------------------------------
			;---------------------------------------------------------------
			;		Leggo il contenuto del registro di STATO nella memoria 
MEM_STATO:	nop
			rcall	del15m
			cbi		portA,3			; azzero CS
			nop
			ldi		dato, 0xD7		; OP code per lettura del registro di stato
			rcall	wr_byte			 
			nop						
	
		
			nop
			nop
			nop
			nop
			ldi		contB, 2
			nop
			nop
			nop
			nop
ciclo_read_status:					
			nop					
			nop
			rcall	rd_byte
			
U_M1:	  	sbis    UCSRA,UDRE
			rjmp    U_M1
			out  	UDR,dato			;Scrivi il codice di ritorno sulla seriale
			rcall	del15m	
			dec		contB
			cpi		contB, 0
			brne	ciclo_read_status
			nop
			nop
			sbi		portA,3			; attivo CS
			ret

			;---------------------------------------------------------------
			;		Programma la memoria a 256 byte di buffer 
MEM_PROG:	nop
			rcall	del15m
			cbi		portA,3			; azzero CS
			nop
			ldi		dato, 0x3D		; OP code per programmare la memoria a 256 byte
			rcall	wr_byte	
			ldi		dato, 0x2A		
			rcall	wr_byte
			ldi		dato, 0x80		
			rcall	wr_byte		
			ldi		dato, 0xA6		
			rcall	wr_byte					 		 
			nop						

			nop
			nop
			sbi		portA,3			; attivo CS
			ret
			;---------------------------------------------------------------
			;	WRITE  BYTE
			;	Routine che converte un byte in forma seriale  
			;	e lo invia alla memoria assieme al relativo clock                                                              
			;   Il dato deve essere sincronizzato sul fronte si SALITA di ck

wr_byte:
		
			nop
			ldi		cont, 8		; contatore inizializzato a 8
			mov 	temp, dato
			nop

w_inizio:		
			cbi		portA,0		; azzero CK
			nop
			nop
			nop
			lsl		temp		; scorrimento a sinistra
			brcs	w_uno		; salta se il carry  1
			rjmp	w_zero

w_uno:		nop
			sbi		portA,2		; attivo SIN
			nop
			nop
			sbi		portA,0		; attivo CK
			nop
			nop
			rjmp	w_fine

w_zero:		nop
			cbi		portA,2		; azzero SIN
			nop
			nop
			sbi		portA,0		; attivo CK
			nop
			nop
			rjmp	w_fine

w_fine:		dec		cont
			cpi		cont,0
			brne	w_inizio
			nop
			ret


			;-------------------------------------------------------------------
			;	READ  BYTE
			;	Routine che legge dalla memoria un byte in forma seriale
			;	e lo converte in forma parallela. Il dato  sincronizzato con il
			;	fronte di discesa del clock.

rd_byte:
			ldi		temp, 0x00
			ldi		dato, 0x00
			nop
			ldi		cont, 8		; contatore inizializzato a 8
			nop
r_inizio:
			sbi		portA, 0	; attivo il clock
			nop
			nop
			cbi		portA, 0	; azzero Ck
			nop
			nop
			nop
			nop
			in		dato, pinA
			andi	dato, 0b00000010	; maschero tutti i bit tranne bit1 (S_OUT)
			cpi 	dato, 0x00
			brne	r_uno
			rjmp	r_zero
r_uno:		nop
			sec					;porto a uno il carry
			rol		temp
			rjmp 	r_fine
r_zero: 	nop
			clc					;azzero il carry
			rol		temp
			rjmp	r_fine
r_fine:	
			nop
			dec		cont
			cpi		cont,0
			brne	r_inizio
			mov		dato, temp
			nop
			ret


